/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.2' (BDS version 1.1.3135.0) */

#include "service_if.h"
#include <stdint.h>
#include "app_trace.h" 
#include "ble_myprofile.h" 

static ble_myprofile_t    m_myprofile; 



/**@brief Function for handling the MyProfile events.
 *
 * @details This function will be called for all MyProfile events which are passed to
 *          the application.
 *
 * @param[in]   p_myprofile   MyProfile structure.
 * @param[in]   p_evt   Event received from the MyProfile.
 */
static void on_myprofile_evt(ble_myprofile_t * p_myprofile, ble_myprofile_evt_t * p_evt)
{
    switch (p_evt->evt_type)
    { 
        case BLE_MYPROFILE_MYCHARACTERISTIC_EVT_NOTIFICATION_ENABLED:
            app_trace_log("[Bluetooth_IF]: MYPROFILE_MYCHARACTERISTIC evt NOTIFICATION_ENABLED. \r\n");
            break;
        case BLE_MYPROFILE_MYCHARACTERISTIC_EVT_NOTIFICATION_DISABLED:
            app_trace_log("[Bluetooth_IF]: MYPROFILE_MYCHARACTERISTIC evt NOTIFICATION_DISABLED. \r\n");
            break;
        case BLE_MYPROFILE_MYCHARACTERISTIC_EVT_CCCD_WRITE:
            app_trace_log("[Bluetooth_IF]: MYPROFILE_MYCHARACTERISTIC evt CCCD_WRITE. \r\n");
            break; 
        case BLE_MYPROFILE_MYCHARACTERISTIC_EVT_WRITE:
            app_trace_log("[Bluetooth_IF]: MYPROFILE_MYCHARACTERISTIC evt WRITE. \r\n");
            break; 
        default:
            // No implementation needed.
            break;
    }
}


/**@brief Function for initializing the Services generated by Bluetooth Developer Studio.
 *
 *
 * @return      NRF_SUCCESS on successful initialization of services, otherwise an error code.
 */
uint32_t bluetooth_init(void)
{
    uint32_t    err_code; 
    ble_myprofile_init_t    myprofile_init; 
    

    // Initialize MyProfile.
    memset(&myprofile_init, 0, sizeof(myprofile_init));

    myprofile_init.evt_handler = on_myprofile_evt; 
    memset(&myprofile_init.ble_myprofile_mycharacteristic_initial_value.value,
           0x00,
           sizeof(myprofile_init.ble_myprofile_mycharacteristic_initial_value.value));

    err_code = ble_myprofile_init(&m_myprofile, &myprofile_init);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } 

    return NRF_SUCCESS;
}

/**@brief Function for handling the Application's BLE Stack events.
 *
 * @details Handles all events from the BLE stack of interest to all Bluetooth Developer Studio generated Services.
 *
 * @param[in]   p_ble_evt  Event received from the BLE stack.
 */
void bluetooth_on_ble_evt(ble_evt_t * p_ble_evt)
{ 
    ble_myprofile_on_ble_evt(&m_myprofile, p_ble_evt); 
}
